package com.viettel.campaign.repository;

import com.viettel.campaign.web.dto.CampaignDTO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Pageable;

import javax.persistence.EntityManager;
import javax.persistence.Query;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class CampaignRepositoryImpl implements CampaignRepositoryCustom {

    @Autowired
    EntityManager entityManager;

    @Override
    public List<CampaignDTO> searchCampaignExecute(String agentId, Pageable pageable) {
        List<CampaignDTO> lst = new ArrayList<>();
        String expression = new StringBuilder()
                //.append(" SELECT C.CODECAMPAIGN_ID, C.CAMPAIGN_NAME, C.CONTENT, C.START_TIME, C.END_TIME, C.STATUS ")
                .append(" SELECT CAMPAIGN_ID, COMPLETE_NAME AS CAMPAIGN_NAME, DESCRIPTION AS CONTENT, UPDATE_BY AS START_TIME, UPDATE_BY AS END_TIME, STATUS ")
                .append(" FROM CAMPAIGN_COMPLETE_CODE C ")
                //.append(" INNER JOIN CAMPAIGN_AGENT CA ON C.CAMPAIGN_ID = CA.CAMPAIGN_ID ")
                //.append(" WHERE 1 = 1 ")
                //.append(" AND CA.AGENT_ID = :pAgentId ")
                //.append(" AND C.STATUS IN (2,3) ")
                .toString();

        Query query = entityManager.createNativeQuery(expression);
        //query.setParameter("pAgentId", agentId);

        List<Object[]> data = query.getResultList();

        for (Object[] obj : data) {
            CampaignDTO item = new CampaignDTO();
            item.setCampaignId((BigDecimal) obj[0]);
            item.setCampaignName((String)obj[1]);
            item.setContent((String)obj[2]);
            item.setStartTime((Date)obj[3]);
            item.setEndTime((Date)obj[4]);
            item.setStatus((BigDecimal) obj[5]);

            lst.add(item);
        }

        return lst;
    }
}
